#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "stdio.h"

#pragma comment (exestr, "Search Project by GUID: {E598136F-FCF8-44e0-AACC-4532360F65DC} mavjuz IconEditor")

#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//     
DWORD ColTable[28] = {
        0x00000000,0x00FFFFFF,0x00808080,0x00C0C0C0,
        0x00000080,0x000000FF,0x00008080,0x0000FFFF,
        0x00008000,0x0000FF00,0x00808000,0x00FFFF00,
        0x00800000,0x00FF0000,0x00800080,0x00FF00FF,
        0x00408080,0x0080FFFF,0x00404000,0x0080FF00,
        0x00FF8000,0x00FFFF80,0x00804000,0x00FF8080,
        0x00FF0040,0x008000FF,0x00004080,0x004080FF };
//  
#define ddremove(n) {if (n != NULL) delete n; n = NULL;}

// ---------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
Screen->Cursors[1] = LoadCursor(HInstance, "IDC_PEN");
Screen->Cursors[2] = LoadCursor(HInstance, "IDC_PIPETKA");
Screen->Cursors[3] = LoadCursor(HInstance, "IDC_FLOOD");
Screen->Cursors[4] = LoadCursor(HInstance, "IDC_SCALE");
Screen->Cursors[5] = LoadCursor(HInstance, "IDC_FIGURES");
    ColorBk = ColTable[1];
    ColorPen = ColTable[0];
    PalIndex = 0;
    mScale = 8;
    mSize = 32;
    SmallIcon->Canvas->Draw(0,0,Form1->Icon);
    BigIcon->Refresh();
    PencilButtonClick(NULL);
}
//////////////////////////////////////////////////////////
//  
//////////////////////////////////////////////////////////
// ---------------------------------------------------------
//   MouseDown  BigIcon  SmallIcon
void __fastcall TForm1::BigIconMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
int vX,vY;
    TCanvas* canv;
    canv=SmallIcon->Canvas;
    mEdited=TRUE;
    if (Button == mbLeft)
    {
        canv->Pen->Color = (TColor) ColorPen;
        canv->Brush->Color = (TColor) ColorPen;
    }
    else if (Button == mbRight)
    {
        canv->Pen->Color = (TColor) ColorBk;
        canv->Brush->Color = (TColor) ColorBk;
    }
    else return;
    //     -  
    if (mDown)
    {
        mDown=FALSE;
        if (TmpImage)
        {
            SmallIcon->Picture = TmpImage->Picture;
            BigIconPaint(NULL);
            ddremove(TmpImage);
        }
        return;
    }
    ddremove(TmpImage);
    mDown = TRUE;

    SmallIcon->Canvas->Pen->Width = 1;

    if (TestSender(Sender,X,Y,vX,vY)) return;

    // 
    if (ScaleButton->Down)
    {
        int nScale = mScale;
        if (Button == mbLeft) nScale++;  // 
        if (Button == mbRight) nScale--; // 
        if ((nScale < 2)||(mSize*nScale > 256)) return;
        mScale=nScale;
        BigIcon->Height = mSize*mScale;
        BigIcon->Width = mSize*mScale;
        BigIcon->Refresh();
        mDown = FALSE;
        return;
    }

    // 
    if (PointButton->Down)
    {
        DoPoint(Button,vX,vY);
        return;
    }

    // 
    if (FloodButton->Down)
    {
        canv->FloodFill(vX, vY, canv->Pixels[vX][vY], fsSurface);
        BigIconPaint(NULL);
        return;
    }

    // 
    if (EraseButton->Down)
    {
        canv->Pen->Color = (TColor) ColorBk;
        canv->Brush->Color = (TColor) ColorBk;
        RECT rc;
        SetRect(&rc,vX-1, vY-1, vX+2, vY+2);
        canv->FillRect((TRect)rc);
        canv->Pen->Width = 3;
        canv->MoveTo(vX,vY);
        BigIconPaint(NULL);
        return;
    }

    // 
    if (PencilButton->Down)
    {
        canv->MoveTo(vX,vY);
        canv->Pixels[vX][vY]= (TColor) canv->Pen->Color;
        BigIconPaint(NULL);
        return;
    }
    mX = vX;
    mY = vY;
    //    
    TmpImage = new TImage(this);
    TmpImage->Picture = SmallIcon->Picture;
}
// ---------------------------------------------------------
//   MouseMove  BigIcon  SmallIcon
void __fastcall TForm1::BigIconMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
int vX, vY;
    if (TestSender(Sender,X,Y,vX,vY)) return;
        char buf[16];
        wsprintf(buf,"%d, %d",vX,vY);
        Label2->Caption = buf;

    if (!mDown) return;
    if (!(Shift.Contains(ssRight)||Shift.Contains(ssLeft)))
        return;

    // 
    if (PointButton->Down)
    {
        TMouseButton Button;
        if (Shift.Contains(ssLeft)) Button = mbLeft;
        else Button = mbRight;
        DoPoint(Button,vX,vY);
        return;
    }

    // 
    if (FloodButton->Down)
        return;

    // 
    if (PencilButton->Down)
    {
        SmallIcon->Canvas->LineTo(vX,vY);
        SmallIcon->Canvas->Pixels[vX][vY]= SmallIcon->Canvas->Pen->Color;
        BigIconPaint(NULL);
        return;
    }

    // 
    if (EraseButton->Down)
    {
        SmallIcon->Canvas->LineTo(vX,vY);
        BigIconPaint(NULL);
        return;
    }

    //     
    DrawShape(vX, vY);
    BigIconPaint(NULL);
}
// ---------------------------------------------------------
//   MouseUp  BigIcon  SmallIcon
void __fastcall TForm1::BigIconMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
int vX,vY;
    //      ,  
    if (!mDown) return;

    if (TestSender(Sender,X,Y,vX,vY)) return;
    mDown=FALSE;

    //   
    if ((FloodButton->Down) || (PencilButton->Down))
        return;

    // 
    if (EraseButton->Down)
    {
        mDown=FALSE;
        SmallIcon->Canvas->Pen->Width = 1;
        return;
    }

    //     
    DrawShape(vX, vY);
    BigIconPaint(NULL);
    //    
    ddremove(TmpImage);
    Label3->Caption = "";
}
// ---------------------------------------------------------
//   ,    
void __fastcall TForm1::DrawShape(int X, int Y)
{
    TRect rc; //       rect
    if ((!TmpImage)||(!mDown)) return;

    //   :
    BitBlt(SmallIcon->Canvas->Handle,0,0,32,32,
        TmpImage->Canvas->Handle,0,0,SRCCOPY);

    //        
    //  .  Rect  "" 
    if (X < mX)
    {
        rc.Left = X;
        rc.Right = mX;
    }
    else
    {
        rc.Right = X+1;
        rc.Left = mX;
    }

    if (Y < mY)
    {
        rc.Top = Y;
        rc.Bottom = mY;
    }
    else
    {
        rc.Bottom = Y+1;
        rc.Top = mY;
    }

    //  ,   
    if (EllipseButton->Down)
        SmallIcon->Canvas->Arc(rc.Left, rc.Top, rc.Right, rc.Bottom, 0, 0, 0, 0);
    else if (FillEllipseButton->Down)
        SmallIcon->Canvas->Ellipse(rc.Left, rc.Top, rc.Right, rc.Bottom);
    else if (RectButton->Down)
        SmallIcon->Canvas->FrameRect(rc);
    else if (FillRectButton->Down)
        SmallIcon->Canvas->FillRect(rc);
    else if (LineButton->Down)
    {
        SmallIcon->Canvas->MoveTo(mX,mY);
        SmallIcon->Canvas->LineTo(X,Y);
        SmallIcon->Canvas->Pixels[X][Y] = SmallIcon->Canvas->Pen->Color;
    }
    char buf[16];   //     
    wsprintf(buf,"%d, %d",X-mX,Y-mY);
    Label3->Caption = buf;
}
// ---------------------------------------------------------
//        
bool __fastcall TForm1::TestSender(TObject * Sender, int X, int Y, int& vX, int& vY)
{
    if (Sender == BigIcon)
    {   //     
        vX=X/mScale;
        vY=Y/mScale;
        return false;
    }
    if (Sender == SmallIcon)
    {   //      
        vX=X;
        vY=Y;
        return false;
    }
return true;
}
// ---------------------------------------------------------
//   
void __fastcall TForm1::DoPoint(TMouseButton Btn, int vX, int vY)
{
        if (Btn == mbLeft)
        {
                ColorPen = SmallIcon->Canvas->Pixels[vX][vY];
                DrawStdRect(Palette->Canvas,4,4,16,16,
                        (TColor) ColorPen);
        }
        if (Btn == mbRight)
        {
                ColorBk = SmallIcon->Canvas->Pixels[vX][vY];
                DrawStdRect(Palette->Canvas,12,12,16,16,
                        (TColor) ColorBk);
                DrawStdRect(Palette->Canvas,4,4,16,16,
                        (TColor) ColorPen);
        }
}
// ---------------------------------------------------------
//  OnPaint   
void __fastcall TForm1::BigIconPaint(TObject *Sender)
{
    StretchBlt(BigIcon->Canvas->Handle,0,0,mSize*mScale,mSize*mScale,
                SmallIcon->Canvas->Handle,0,0,mSize,mSize,SRCCOPY);
}

//////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////
// ---------------------------------------------------------
//   3D ""    
void __fastcall TForm1::DrawStdRect(TCanvas* canv,
                            int X,int Y,int W,int H,COLORREF col)
{
    HBRUSH hb;
    RECT rc;
    SetRect(&rc,X,Y,X+W,Y+H);
    DrawEdge(canv->Handle,&rc,EDGE_SUNKEN,BF_RECT);
    hb = CreateSolidBrush(col);
    InflateRect(&rc,-2,-2);
    FillRect(canv->Handle,&rc,hb);
    DeleteObject(hb);
};
// ---------------------------------------------------------
//  
void __fastcall TForm1::PalettePaint(TObject *Sender)
{
    TCanvas* canv=Palette->Canvas;
    DrawStdRect(canv,0,0,31,32,0x00FFFFFF);
    DrawStdRect(canv,12,12,16,16,ColorBk);
    DrawStdRect(canv,4,4,16,16,ColorPen);
    int y=0;
    for (int n=31;n<255;n+=16)
    {
        DrawStdRect(canv,n,0,16,16,ColTable[y++]);
        DrawStdRect(canv,n,16,16,16,ColTable[y++]);
    }
}
// ---------------------------------------------------------
//    
void __fastcall TForm1::PaletteMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (X<31) return;
    int i=((X-31)/16)*2+(Y<15?0:1);

    PalIndex = i;
    if (Button == mbLeft) ColorPen = ColTable[i];
    if (Button == mbRight) ColorBk = ColTable[i];
    DrawStdRect(Palette->Canvas,12,12,16,16,(TColor) ColorBk);
    DrawStdRect(Palette->Canvas,4,4,16,16,(TColor) ColorPen);
}
// ---------------------------------------------------------
//    
void __fastcall TForm1::PaletteDblClick(TObject *Sender)
{
    ColorDialog->Color = (TColor) ColTable[PalIndex];
    if(ColorDialog->Execute())
    {
        ColTable[PalIndex] = ColorDialog->Color;
        ColorPen = (DWORD) ColorDialog->Color;
        Palette->Refresh();
    }
}

//////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////
// ---------------------------------------------------------
// ""
void __fastcall TForm1::N2Click(TObject *Sender)
{
while (AskSaveFile())
  {
    if (!OpenDialog->Execute()) return;
    TIcon* ico = new TIcon();
    ico->LoadFromFile(OpenDialog->FileName);
    if (!(ico->Handle && ico->Width && ico->Height))
    {
        MesEr("   ,   \r\
 .   !",0);
        continue;
    }
    if ((ico->Width==16) && (ico->Height==16))
    {
        mSize=16;
        mScale=16;
    }
    else if ((32==ico->Width) && (32==ico->Height))
    {
        mSize=32;
        mScale=8;
    }
    else
    {
        MesEr("    16x16  32x32 \r\
  !",0);
        continue;
    }
    N9Click(NULL);
    SmallIcon->Width = mSize;
    SmallIcon->Height = mSize;
    SmallIcon->Canvas->Draw(0,0,ico);
    BigIcon->Height = mSize*mScale;
    BigIcon->Width = mSize*mScale;
    BigIcon->Refresh();
    SaveDialog->FileName = OpenDialog->FileName;
    char buf[256]="  - ";
    if (!GetFileTitle(OpenDialog->FileName.c_str(),&buf[18],256))
        Form1->Caption = buf;
    else
        Form1->Caption = buf[15] = 0;
    mValidFileName = TRUE;
    if (SmallIcon->Width == 32 )
        Label1->Caption = "32x32";
    else
        Label1->Caption = "16x16";
    return;
  }
}
// ---------------------------------------------------------
// ""
void __fastcall TForm1::N3Click(TObject *Sender)
{
    DoSaveFile(1);
}
// ---------------------------------------------------------
// " ..."
void __fastcall TForm1::N4Click(TObject *Sender)
{
    DoSaveFile(0);
}
// ---------------------------------------------------------
// ""
void __fastcall TForm1::N6Click(TObject *Sender)
{
    if (AskSaveFile()) Application->Terminate();
}
// ---------------------------------------------------------
// ""
void __fastcall TForm1::N15Click(TObject *Sender)
{
    PencilButton->Down = true;
    PencilButtonClick(NULL);
}
// ---------------------------------------------------------
// ""
void __fastcall TForm1::N16Click(TObject *Sender)
{
    LineButton->Down = true;
    PencilButtonClick(NULL);
}
// ---------------------------------------------------------
// ""
void __fastcall TForm1::N17Click(TObject *Sender)
{
    EllipseButton->Down = true;
    PencilButtonClick(NULL);
}
// ---------------------------------------------------------
// ""
void __fastcall TForm1::N18Click(TObject *Sender)
{
    RectButton->Down = true;
    PencilButtonClick(NULL);
}
// ---------------------------------------------------------
// ""
void __fastcall TForm1::N19Click(TObject *Sender)
{
    FloodButton->Down = true;
    PencilButtonClick(NULL);
}
// ---------------------------------------------------------
// ""
void __fastcall TForm1::N20Click(TObject *Sender)
{
    EraseButton->Down = true;
    PencilButtonClick(NULL);
}
// ---------------------------------------------------------
// " "
void __fastcall TForm1::N21Click(TObject *Sender)
{
    FillEllipseButton->Down = true;
    PencilButtonClick(NULL);
}
// ---------------------------------------------------------
// " "
void __fastcall TForm1::N22Click(TObject *Sender)
{
    FillRectButton->Down = true;
    PencilButtonClick(NULL);
}
// ---------------------------------------------------------
// ""
void __fastcall TForm1::N27Click(TObject *Sender)
{
    PointButton->Down = true;
    PencilButtonClick(NULL);
}
// ---------------------------------------------------------
// ""
void __fastcall TForm1::N28Click(TObject *Sender)
{
    ScaleButton->Down = true;
    PencilButtonClick(NULL);
}
// ---------------------------------------------------------
// " "
void __fastcall TForm1::N26Click(TObject *Sender)
{
    AboutBox->Show();
}
// ---------------------------------------------------------
//  : "->"
void __fastcall TForm1::N9Click(TObject *Sender)
{
    SmallIcon->Canvas->Brush->Color = (TColor) ColorBk;
    RECT rc;
    SetRect(&rc,0,0,mSize,mSize);
    SmallIcon->Canvas->FillRect(rc);
    BigIcon->Refresh();
}
// ---------------------------------------------------------
//  : "->"
void __fastcall TForm1::N8Click(TObject *Sender)
{
    RECT rc;
    SetRect(&rc,0,0,mSize,mSize);
    InvertRect(SmallIcon->Canvas->Handle,&rc);
    SmallIcon->Refresh();
    BigIcon->Refresh();
}
// ---------------------------------------------------------
//  : "-> " "16x16"/"32x32"
void __fastcall TForm1::N10Click(TObject *Sender)
{
int nSize;
    if (Sender == N10) nSize = 16;
    else if (Sender == N11) nSize = 32;
    else return;
    if (mSize==nSize)
    {
        MesEr("    !",0);
    }
    else
    {
        SmallIcon->Width = 32;
        SmallIcon->Height = 32;
        StretchBlt(SmallIcon->Canvas->Handle,
            0,0,nSize,nSize,
            SmallIcon->Canvas->Handle,
            0,0,mSize,mSize,SRCCOPY);
        mSize = nSize;
        mScale = 256/mSize;
        SmallIcon->Width = mSize;
        SmallIcon->Height = mSize;
        SmallIcon->Refresh();
        BigIcon->Height = mSize*mScale;
        BigIcon->Width = mSize*mScale;
        BigIcon->Refresh();
        if (SmallIcon->Width == 32 )
            Label1->Caption = "32x32";
        else
            Label1->Caption = "16x16";
    }
}
// ---------------------------------------------------------
// ""
void __fastcall TForm1::N24Click(TObject *Sender)
{
    Application->HelpCommand(HELP_CONTENTS, 0);
}
// ---------------------------------------------------------
//  : "->" "16x16"/"32x32"
void __fastcall TForm1::N16x161Click(TObject *Sender)
{
if(AskSaveFile())
  {
    N9Click(NULL);
    if (Sender == N16x161)
        mSize=16;
    else if (Sender == N32x321)
        mSize=32;
    else return;
    mScale = 256/mSize;
    SmallIcon->Width = mSize;
    SmallIcon->Height = mSize;
    SmallIcon->Refresh();
    BigIcon->Height = mSize*mScale;
    BigIcon->Width = mSize*mScale;
    BigIcon->Refresh();
    if (SmallIcon->Width == 32 )
        Label1->Caption = "32x32";
    else
        Label1->Caption = "16x16";
    SaveDialog->FileName = "NewIcon.ico";
    Form1->Caption=" ";
    mValidFileName = FALSE;
  }
}
// ---------------------------------------------------------
//  : " "
void __fastcall TForm1::N32Click(TObject *Sender)
{
    N32->Checked = !N32->Checked;
}
//////////////////////////////////////////////////////////
//  
//////////////////////////////////////////////////////////
// ---------------------------------------------------------
//     
void __fastcall MesEr(char* st,DWORD val)
{
        char buf[128];
        wsprintf(buf,st,val);
        Application->MessageBox(buf," ",
                            val?MB_ICONERROR:MB_ICONINFORMATION);
}
// ---------------------------------------------------------
// : " "
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
    if (AskSaveFile()) Action = caFree;
    else Action=caNone;
}
// ---------------------------------------------------------
//      
// return false,  ""
bool __fastcall TForm1::AskSaveFile()
{
    while (mEdited)
    {
        int r=Application->MessageBox("  !\r  ?","!",MB_YESNOCANCEL | MB_ICONQUESTION);
        if (r==IDYES) DoSaveFile(1);
        if (r==IDNO) return true;
        if (r==IDCANCEL) return false;
    }
return true;
}
// ---------------------------------------------------------
//   ,  
// return false,   
bool __fastcall TForm1::DoSaveFile(DWORD type)
{   // type = 1 -> Save, 0 - Save As...
    if ((type && mValidFileName)||(SaveDialog->Execute()))
        return SaveIcon();
return false;
}
//---------------------------------------------------------------------------
//   ,  
// return false,    
bool __fastcall TForm1::SaveIcon()
{
MYICONINFO mi;  //     SaveIconFmt
    ZeroMemory(&mi,sizeof(MYICONINFO));
    mi.nWidth = mSize;
    mi.nHeight = mSize;
    mi.cPlanes = 1;
    mi.cBitsPixel = 24;

    //  
    char buf[4096];
    char buz[256];
    char* bub=&buz[4];
    ZeroMemory(buf,4096);
    ZeroMemory(buz,256);
    mi.lpbANDbits = bub; //    
    mi.lpbXORbits = buf; //  

BITMAPINFO bi; //     DIB 
    ZeroMemory(&bi,sizeof(BITMAPINFO));
    bi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    bi.bmiHeader.biHeight = mSize;
    bi.bmiHeader.biWidth = mSize;
    bi.bmiHeader.biPlanes  = 1;
    bi.bmiHeader.biBitCount = 1;
    bi.bmiHeader.biCompression = BI_RGB;
    SetLastError(0);

if (N32->Checked)
  {
    Graphics::TBitmap* msk = new Graphics::TBitmap();
    msk->Assign(SmallIcon->Picture->Bitmap);
    msk->TransparentColor = (TColor) ColorBk;
    msk->TransparentMode = tmFixed;
    msk->Transparent = true;

    if (GetDIBits(msk->Canvas->Handle,
        msk->MaskHandle,
        0,mSize,
        bub,
        &bi,
        DIB_RGB_COLORS)==0)
    {
        MesEr(" Mask1: %d",GetLastError());
        delete msk;
        return false;
    }
    delete msk;
  }

    //   lpbANDbits 
    //    
  HDC hdc = CreateCompatibleDC(SmallIcon->Canvas->Handle);
    //  ...   Bitmap
  HBITMAP hbm = CreateCompatibleBitmap(
                        SmallIcon->Canvas->Handle,
                        mSize,mSize+1);
    SelectObject(hdc,hbm);
    // FloodFill(hdc,0,0,0x00000000);
    //    
    if(SetDIBitsToDevice(hdc, 0, 0, mSize, mSize, 0, 0,
            0, mSize, bub, &bi, DIB_RGB_COLORS)==0)
    {
        MesEr(" Mask2: %d",GetLastError());
        DeleteObject(hbm); //  Bitmap
        return false;
    }
    //       (AND)
    if(!BitBlt(hdc, 0, 0, mSize, mSize,
            SmallIcon->Canvas->Handle, 0, 0, SRCERASE))
    {
        MesEr(" Blt: %d",GetLastError());
        DeleteObject(hbm); //  Bitmap
        return false;
    }
    DeleteDC(hdc); //  
    //  hmp     SmallIcon

    bi.bmiHeader.biBitCount = mi.cBitsPixel;
    //    lpbANDbits
    if (GetDIBits(SmallIcon->Canvas->Handle,
        hbm,
        0,mSize,
        buf,
        &bi,
        DIB_RGB_COLORS)==0)
    {
        MesEr(" Col: %d",GetLastError());
        DeleteObject(hbm); //  Bitmap
        return false;
    }
    DeleteObject(hbm); //  Bitmap

    //     
    if(!SaveIconFmt(&mi,SaveDialog->FileName.c_str(),0))
    {
        char bu[256]="  - ";
        if (!GetFileTitle(SaveDialog->FileName.c_str(),&bu[18],256))
            Form1->Caption = bu;
        else
            Form1->Caption = bu[15] = 0;

        mValidFileName = TRUE;
        mEdited = FALSE;
        return true;
    }
return false;
}

//////////////////////////////////////////////////////////
//  
//////////////////////////////////////////////////////////
// ---------------------------------------------------------
//      
DWORD __fastcall TForm1::SaveIconFmt(MYICONINFO* mi,
                            char* filename, DWORD type)
{
ICONDIRHEADER ih;   // File Header
    ZeroMemory(&ih,sizeof(ICONDIRHEADER));
    ih.idCount = 1;
    ih.idType = 1;

ICONDIRENTRY id;    // Entry Header
    ZeroMemory(&id,sizeof(ICONDIRENTRY));
    id.bWidth = mSize;
    id.bHeight = mSize;
    id.bColorCount = 0; // 2, 8, 16
    id.wPlanes = 0;
    id.dwBytesInRes = (mi->cBitsPixel * mi->nWidth * mi->nHeight)/8
                        + mi->nHeight*4
                        + sizeof(BITMAPINFOHEADER);
    id.dwImageOffset = sizeof(ICONDIRHEADER)
                        + sizeof(ICONDIRENTRY);

BITMAPINFOHEADER bi;    // Bitmap data header
    ZeroMemory(&bi,sizeof(BITMAPINFOHEADER));
    bi.biSize = sizeof(BITMAPINFOHEADER);
    bi.biWidth = mi->nWidth;
    bi.biHeight = mi->nHeight * 2;
    bi.biPlanes = 1;
    bi.biBitCount = mi->cBitsPixel;

FILE *stream;
    if ((stream = fopen(filename, "wb")) == NULL)
    {
        MesEr("Cannot create file!",0);
        return 1;
    }
    // ICONDIRHEADER
    fwrite(&ih, sizeof(ICONDIRHEADER), 1, stream);
    // ICONDIRENTRY[0]
    fwrite(&id, sizeof(ICONDIRENTRY), 1, stream);
    // BITMAPINFOHEADER
    fwrite(&bi, sizeof(BITMAPINFOHEADER), 1, stream);
    // Color
    fwrite((void*) mi->lpbXORbits,
        ((mi->cBitsPixel * mi->nWidth * mi->nHeight)/8),
        1, stream);
    fwrite((void*) mi->lpbANDbits,
        mi->nHeight*4,
        1, stream);
    fclose(stream);
return 0;
}
// ---------------------------------------------------------
//       
void __fastcall TForm1::PencilButtonClick(TObject *Sender)
{
    if (PencilButton->Down)
    {
        BigIcon->Cursor = (TCursor) 1;
        SmallIcon->Cursor = (TCursor) 1;
    }
    else if (PointButton->Down)
    {
        BigIcon->Cursor = (TCursor) 2;
        SmallIcon->Cursor = (TCursor) 2;
    }
    else if (FloodButton->Down)
    {
        BigIcon->Cursor = (TCursor) 3;
        SmallIcon->Cursor = (TCursor) 3;
    }
    else if (EraseButton->Down)
    {
        BigIcon->Cursor = crArrow;
        SmallIcon->Cursor = crArrow;
    }
    else if (ScaleButton->Down)
    {
        BigIcon->Cursor = (TCursor) 4;
        SmallIcon->Cursor = (TCursor) 4;
    }
    else
    {
        BigIcon->Cursor = (TCursor) 5;
        SmallIcon->Cursor = (TCursor) 5;
    };
}



